	TITLE	XCTEST

	LOCALS	@@

; Data segment

_DATA		SEGMENT WORD PUBLIC 'DATA'

; Externals

	EXTRN	TimerProc:DWORD

_DATA		ENDS

; Data group

DGROUP		GROUP	_DATA

; Code segment

XCTEST_TEXT	SEGMENT	BYTE PUBLIC 'CODE'

	ASSUME	CS:XCTEST_TEXT,DS:DGROUP

	PUBLIC	InitInt08
	PUBLIC	DoneInt08

; CS-based variables

OldInt08	DD	0	;Saved INT 08H vector

; Install INT 08H

InitInt08:

	MOV	AX,3508H
	INT	21H
	MOV	WORD PTR OldInt08[0],BX
	MOV	WORD PTR OldInt08[2],ES
	PUSH	DS
	PUSH	CS
	POP	DS
	MOV	DX,OFFSET Int08Handler
	MOV	AX,2508H
	INT	21H
	POP	DS
	RET

; Remove INT 08H

DoneInt08:

	PUSH	DS
	LDS	DX,DWORD PTR OldInt08
	MOV	AX,2508H
	INT	21H
	POP	DS
	RET

; INT 08H handler

Int08Handler:

	PUSH	ES
	PUSH	DS
	PUSH	BP
	PUSH	DI
	PUSH	SI
	PUSH	AX
	PUSH	BX
	PUSH	CX
	PUSH	DX
	MOV	DX,SEG DGROUP
	MOV	DS,DX
	CALL	TimerProc
	POP	DX
	POP	CX
	POP	BX
	POP	AX
	POP	SI
	POP	DI
	POP	BP
	POP	DS
	POP	ES
	JMP	OldInt08

XCTEST_TEXT	ENDS

	END
